#include <iostream>

#include <Application.h>
#include <Message.h>
#include <View.h>
#include <Window.h>


class SimpleView : public BView {
public:
	SimpleView(const char* name) : BView(BRect(0, 0, 400, 400), name, B_FOLLOW_ALL_SIDES, 0) {
	}
	
	virtual void MouseDown(BPoint point) {
		Window()->CurrentMessage()->PrintToStream();
	}

	virtual void MouseUp(BPoint point) {
		Window()->CurrentMessage()->PrintToStream();
	}
};


class SimpleWindow : public BWindow {
public:
	SimpleWindow() : BWindow(BRect(100, 100, 500, 500), "Hello", B_TITLED_WINDOW, 0) {
		fView = new SimpleView("fView");
		AddChild(fView);
	}
	
	bool QuitRequested() {
		be_app->PostMessage(B_QUIT_REQUESTED);
		return true;
	}
private:
	SimpleView* fView;
};


class MouseTest : public BApplication {
public:
	MouseTest(): BApplication("application/x-vnd.MouseTest") {
		fWindow = new SimpleWindow();
		fWindow->Show();
	}
private:
	SimpleWindow* fWindow;
};

int main(int argc, char** argv) {
	MouseTest* app = new MouseTest();
	app->Run();
	delete app;
	return B_OK;
}
